<cfsilent>
	<cfset path2logs = GetProfileString("#request.path2site#\cfWatcher.ini", "paths", "path2logs")>
	<cfdirectory action="LIST" name="getLogFilesList" directory="#path2logs#" filter="*Short*.log">
	<cfquery name="orderLogFiles" dbtype="query">
		Select name, size, dateLastModified
		From getLogFilesList
		Order by dateLastModified desc
	</cfquery>
	<cfparam name="logFile" default="">
	<cffunction name="getByteArray" access="private" returnType="any" output="no">
		<cfargument name="size" type="numeric" required="true" />
		<cfscript>
			var emptyByteArray = createObject("java", "java.io.ByteArrayOutputStream").init().toByteArray();
			var byteClass = emptyByteArray.getClass().getComponentType();
			var byteArray = createObject("java","java.lang.reflect.Array").newInstance(byteClass, arguments.size);
			return byteArray;
		</cfscript>
	</cffunction>
	<cffunction name="unzip" access="public" returntype="string" output="no" hint="uncompresses a byte array and returns a string">
		<cfargument name="compByteArray" type="binary" required="yes" hint="a compressed byte array" />
		<cfscript>
			var decompresser = createObject("java","java.util.zip.Inflater").init();
			var bos = createObject("java","java.io.ByteArrayOutputStream").init(javaCast("int",len(arguments.compByteArray)));
			var buf = getByteArray(1024);
			var returnString = "";
			var count = 0;
			decompresser.setInput(arguments.compByteArray);
			while (not decompresser.finished())
			{
				count = decompresser.inflate(buf);
				bos.write(buf, 0, count);
			}
			decompresser.end();
			bos.close();
			returnString = createObject("java","java.lang.String").init(bos.toByteArray(),"UTF-8");
			return returnString.toString();
		</cfscript>
	</cffunction>
</cfsilent>

<cfoutput>
	<table align="right" width="100%">
		<form name="logFrm" action="index.cfm" method="get">
			<input name="action" type="Hidden" value="#action#">
			<tr>
				<td>
					<select name="logFile" onchange="document.logFrm.submit();">
						<option value="">
						<cfloop query="orderLogFiles">
							<option value="#name#"> #name# (#DateFormat(dateLastModified, "mmm dd, yyyy")# #TimeFormat(dateLastModified, "HH:mm:ss")#) (#NumberFormat(Val(size/1024), "_.__")#K)
						</cfloop>
					</select>
				</td>
			</tr>
		</form>
	</table>
	<br><br>
	<cfflush interval="2">
	<cfif Len(logFile) gt 0>
		<cfif FileExists("#path2logs#/#logFile#")>
			<cfscript>
				fileReader = CreateObject("java", "java.io.FileReader");
				fileReader.init("#path2logs#/#logFile#");
				br = CreateObject("java", "java.io.BufferedReader");
				br.init(fileReader);
				// Counters for the loop
				TotalNumRecords = 0;
			</cfscript>
			<cfset logArray = ArrayNew(1)>
			<cftry>
				<cfloop condition="true">
					<cfset line = br.readLine()>
					<cfset TotalNumRecords = TotalNumRecords + 1>
					<cfset logArray[TotalNumRecords] = '<tr><td valign="top" align="right"><a target="_blank" href="index.cfm?action=logs.details&noDesign=1&id=#TotalNumRecords#&logFileShort=#logFile#&logFile=#ReplaceNoCase(logFile, 'Short', '', 'All')#">View</a></td><td align="left">#unzip(ToBinary(line))#</td></tr>'>
				</cfloop>
				<cfcatch type="coldfusion.runtime.UndefinedVariableException">
					<!--- this indicates end of file, ok to ignore error --->
				</cfcatch>
			</cftry>
			<cfif ArrayLen(logArray) gt 0>
				<table>
					<cfloop index="i" from="#ArrayLen(logArray)#" to="1" step="-1">
						#logArray[i]#
					</cfloop>
				</table>
			</cfif>
		<cfelse>
			No such log file.
		</cfif>
	</cfif>
</cfoutput>
