<cfcomponent output="Yes" displayname="manageThreads">
	<cfset thisThread = createobject("java", "java.lang.Thread")>
	<cfset threadClass = createobject("java", "java.lang.Thread").init().getClass()>
	<cfset allThreads = getThreads()>
	
	<cffunction name="getTop" output="Yes">
		<cfset var top = thisThread.currentThread().getThreadGroup()>
		<cfloop condition="top.getParent() neq ''">
			<cfset top = top.getParent()>
		</cfloop>
		<cfreturn top>
	</cffunction>
	
	<cffunction name="getThreads">
		<cfset var threadList = "">
		<cfset var top = getTop()>
		<cfset threadList = createobject("java", "java.lang.reflect.Array").newInstance(threadClass, top.activeCount())>
		<cfset top.enumerate(threadList)>
		<cfreturn threadList>
	</cffunction>
	
	<cffunction name="getThread">
		<cfargument name="poz" default="1" type="numeric">
		<cfreturn allThreads[poz]>
	</cffunction>

	<cffunction name="getThreadStackTrace">
		<cfargument name="poz" default="1" type="numeric">
		<cfset var selectedThread = allThreads[poz]>
		<cfset var elements = selectedThread.getStackTrace()>
		<cfset var selectedThreadSize = ArrayLen(elements)>
		<cfset var threadStackTraceArray = ArrayNew(1)>
		<cfset var i = 0>
		<cfloop index="i" from="1" to="#selectedThreadSize#">
			<cfset threadStackTraceArray[i]["className"] = elements[i].getClassName()>
			<cfset threadStackTraceArray[i]["methodName"] = elements[i].getMethodName()>
			<cfset threadStackTraceArray[i]["fileName"] = elements[i].getFileName()>
			<cfset threadStackTraceArray[i]["lineNumber"] = elements[i].getLineNumber()>
		</cfloop>
		<cfreturn threadStackTraceArray>
	</cffunction>

	<cffunction name="isCF">
		<cfargument name="poz" default="1" type="numeric">
		<cfset var selectedThread = allThreads[poz]>
		<cfset var elements = selectedThread.getStackTrace()>
		<cfset var selectedThreadSize = ArrayLen(elements)>
		<cfset var threadStackTraceArray = ArrayNew(1)>
		<cfset var i = 0>
		<cfset var flName = "">
		<cfloop index="i" from="1" to="#selectedThreadSize#">
			<cfset flName = elements[i].getFileName()>
			<cfif IsDefined("flName") and (flName.endsWith(".cfm") or flName.endsWith(".cfc"))>
				<cfreturn true>
			</cfif>
		</cfloop>
		<cfreturn false>
	</cffunction>

	<cffunction name="getCFsList">
		<cfargument name="poz" default="1" type="numeric">
		<cfset var selectedThread = allThreads[poz]>
		<cfset var elements = selectedThread.getStackTrace()>
		<cfset var selectedThreadSize = ArrayLen(elements)>
		<cfset var threadStackTraceArray = ArrayNew(1)>
		<cfset var i = 0>
		<cfset var flName = "">
		<cfset var CFsList = "">
		<cfloop index="i" from="1" to="#selectedThreadSize#">
			<cfset flName = elements[i].getFileName()>
			<cfif IsDefined("flName") and (flName.endsWith(".cfm") or flName.endsWith(".cfc"))>
				<cfset CFsList = ListAppend(CFsList, flName & ":" & elements[i].getLineNumber(), "/")>
			</cfif>
		</cfloop>
		<cfreturn CFsList>
	</cffunction>
</cfcomponent>