<!---
<cfscript>
factory = createobject("java", "coldfusion.server.ServiceFactory");
</cfscript>
<cfset asd = factory.LicenseService.getProperties()>
<cfdump var="#asd['code']#">
<cfdump var="#asd['sn']#">
--->

<cfsilent>
	<cfscript>
		runtime = CreateObject("java","java.lang.Runtime").getRuntime();
		freeMemory = Round(runtime.freeMemory() / 1024 / 1024);
		totalMemory = Round(runtime.totalMemory() / 1024 / 1024);
		maxMemory = Round(runtime.maxMemory() / 1024 / 1024);
	</cfscript>

	<cfset perfMon = GetMetricData('PERF_MONITOR')>

	<cfset mgmtFactory = createobject("java", "java.lang.management.ManagementFactory")>
	<cfset totalPhysicalMemory = mgmtFactory.OperatingSystemMXBean.getTotalPhysicalMemorySize()/1024>
	<cfset availPhysicalMemory = mgmtFactory.OperatingSystemMXBean.getFreePhysicalMemorySize()/1024>
</cfsilent>
<br>
<cfoutput>
	<table align="center">
		<tr>
			<td>
				<table align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">S E R V E R&nbsp;&nbsp;&nbsp;&nbsp;S T A T S</th>
					</tr>
					<tr>
						<th align="right" class="firstth">OS Name:&nbsp;</th>
						<td>#mgmtFactory.OperatingSystemMXBean.getName()#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">OS Version:&nbsp;</th>
						<td>#mgmtFactory.OperatingSystemMXBean.getVersion ()#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">OS architecture:&nbsp;</th>
						<td>#mgmtFactory.OperatingSystemMXBean.getArch()#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Available processors:&nbsp;</th>
						<td>#mgmtFactory.OperatingSystemMXBean.getAvailableProcessors()#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Virtual Machine version:&nbsp;</th>
						<td>#mgmtFactory.RuntimeMXBean.getVmVersion()#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Instance Name:&nbsp;</th>
						<td>#perfMon.InstanceName#</td>
					</tr>
					<tr>
						<td colspan="2"><br></td>
					</tr>
					<tr>
						<th align="right" class="firstth">Free Memory:&nbsp;</th>
						<td>#freeMemory#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Total Memory:&nbsp;</th>
						<td>#totalMemory#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Max Memory:&nbsp;</th>
						<td>#maxMemory#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Free Allocated (%):&nbsp;</th>
						<td>#Round((freeMemory / Max(1, totalMemory)) * 100)#%</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Allocated (%):&nbsp;</th>
						<td>#Round((totalMemory / Max(1, maxMemory) ) * 100)#%</td>
					</tr>
					<tr>
						<td colspan="2"><br></td>
					</tr>
					<tr>
						<th align="right" class="firstth">Page Hits:&nbsp;</th>
						<td>#perfMon.PageHits#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">DB Hits:&nbsp;</th>
						<td>#perfMon.DBHits#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Bytes In:&nbsp;</th>
						<td>#perfMon.BytesIn# (#KBytes(perfMon.BytesIn)#)</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Bytes Out:&nbsp;</th>
						<td>#perfMon.BytesOut# (#KBytes(perfMon.BytesOut)#)</td>
					</tr>
			
					<tr>
						<th align="right" class="firstth">Overall Server Load:&nbsp;</th>
						<td>#GetMetricData("SIMPLE_LOAD")#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Avg Request Time:&nbsp;</th>
						<td>#GetMetricData("AVG_REQ_TIME")#ms</td>
					</tr>
					<cfif  structKeyExists(server, timerKey)>
						<tr>
							<th align="right" class="firstth">Time online from first tracked request:&nbsp;</th>
							<td>#secsToTime(DateDiff("s", server[timerKey], Now()), "s")#</td>
						</tr>
					</cfif>
					<cfif  structKeyExists(server, trackedRequestsKey)>
						<tr>
							<th align="right" class="firstth">Tracked request from last restart:&nbsp;</th>
							<td>#server[trackedRequestsKey]#</td>
						</tr>
					</cfif>
					<cfif  structKeyExists(server, requestsLengthKey)>
						<tr>
							<th align="right" class="firstth">Length of current debug data in memory:&nbsp;</th>
							<td>#server[requestsLengthKey]#</td>
						</tr>
					</cfif>
					<tr>
						<td colspan="2"><br></td>
					</tr>
					<tr>
						<th align="right" class="firstth">CPU time used by the process on which<br>the Java virtual machine is running:&nbsp;</th>
						<td>#secsToTime(mgmtFactory.OperatingSystemMXBean.getProcessCpuTime()/1000/1000/1000, "s")#</td>
					</tr>
					<!---
					<tr>
						<th align="right" class="firstth">Start time of the Java virtual machine:&nbsp;</th>
						<td>#secsToTime(mgmtFactory.RuntimeMXBean.getStartTime()/1000, "s")#</td>
					</tr>
					--->
					<tr>
						<th align="right" class="firstth">Uptime of the Java virtual machine:&nbsp;</th>
						<td>#secsToTime(mgmtFactory.RuntimeMXBean.getUptime()/1000, "s")#</td>
					</tr>
				</table>
			</td>
			<td valign="top">
				<table width="100%" align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">H E A P&nbsp;&nbsp;&nbsp;&nbsp;M E M O R Y&nbsp;&nbsp;&nbsp;&nbsp;U S A G E</th>
					</tr>
					<tr>
						<th align="right" class="firstth">Initial:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getHeapMemoryUsage().getInit()/1024)#K</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Committed:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getHeapMemoryUsage().getCommitted()/1024)#K</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Max:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getHeapMemoryUsage().getMax()/1024)#K</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Used:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getHeapMemoryUsage().getUsed()/1024)#K</td>
					</tr>
				</table>
				<br>
				<table width="100%" align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">N O N - H E A P&nbsp;&nbsp;&nbsp;&nbsp;M E M O R Y&nbsp;&nbsp;&nbsp;&nbsp;U S A G E</th>
					</tr>
					<tr>
						<th align="right" class="firstth">Initial:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getNonHeapMemoryUsage().getInit()/1024)#K</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Committed:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getNonHeapMemoryUsage().getCommitted()/1024)#K</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Max:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getNonHeapMemoryUsage().getMax()/1024)#K</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Used:&nbsp;</th>
						<td>#Round(mgmtFactory.MemoryMXBean.getNonHeapMemoryUsage().getUsed()/1024)#K</td>
					</tr>
				</table>
				<br>
				<table width="100%" align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">P H Y S I C A L&nbsp;&nbsp;&nbsp;&nbsp;M E M O R Y</th>
					</tr>
					<tr>
						<th align="right" class="firstth">Total (K):&nbsp;</th>
						<td>#Round(totalPhysicalMemory)#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Available (K):&nbsp;</th>
						<td>#Round(availPhysicalMemory)# (#NumberFormat(100*availPhysicalMemory/totalPhysicalMemory, "_._")#%)</td>
					</tr>
				</table>
				<br>
				<table width="100%" align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">C O M M I T&nbsp;&nbsp;&nbsp;&nbsp;C H A R G E (K)</th>
					</tr>
					<tr>
						<th align="right" class="firstth">Limit (total swap space):&nbsp;</th>
						<td>#Round(mgmtFactory.OperatingSystemMXBean.getTotalSwapSpaceSize()/1024)#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Free swap space:&nbsp;</th>
						<td>#Round(mgmtFactory.OperatingSystemMXBean.getFreeSwapSpaceSize()/1024)#</td>
					</tr>
					<tr>
						<th align="right" class="firstth">Virtual memory:&nbsp;</th>
						<td>#Round(mgmtFactory.OperatingSystemMXBean.getCommittedVirtualMemorySize()/1024)#</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
<br>
	<table align="center">
		<tr>
			<td valign="top">
				<table width="100%" align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">M E M O R Y&nbsp;&nbsp;&nbsp;&nbsp;P O O L S&nbsp;&nbsp;&nbsp;&nbsp;W I T H I N&nbsp;&nbsp;&nbsp;&nbsp;T H E&nbsp;&nbsp;&nbsp;&nbsp;JVM&nbsp;&nbsp;&nbsp;&nbsp;M E M O R Y&nbsp;&nbsp;&nbsp;&nbsp;S P A C E S</th>
					</tr>
					<cfloop index="i" from="1" to="#ArrayLen(mgmtFactory.MemoryPoolMXBeans)#">
						<cfif i gt 1>
							<tr class="firstrow">
								<th align="center" colspan="2"></th>
							</tr>
						</cfif>
						<tr>
							<th align="right" class="firstth">Name:&nbsp;</th>
							<td><em><u>#mgmtFactory.MemoryPoolMXBeans[i].getName()#</u></em></td>
						</tr>
						<tr>
							<th align="right" class="firstth">Type:&nbsp;</th>
							<td>#mgmtFactory.MemoryPoolMXBeans[i].getType()#</td>
						</tr>
						<tr>
							<th align="right" class="firstth">Usage:&nbsp;</th>
							<td>#mgmtFactory.MemoryPoolMXBeans[i].getUsage()#</td>
						</tr>
						<tr>
							<th align="right" class="firstth">Collection Usage:&nbsp;</th>
							<td>#mgmtFactory.MemoryPoolMXBeans[i].getCollectionUsage()#</td>
						</tr>
						<tr>
							<th align="right" class="firstth">Peak Usage:&nbsp;</th>
							<td>#mgmtFactory.MemoryPoolMXBeans[i].getPeakUsage()#</td>
						</tr>
						<tr>
							<th valign="top" align="right" class="firstth">Memory Manager Names:&nbsp;</th>
							<td>
								<cfloop index="j" from="1" to="#ArrayLen(mgmtFactory.MemoryPoolMXBeans[i].getMemoryManagerNames())#">
									<cfset gmmn = mgmtFactory.MemoryPoolMXBeans[i].getMemoryManagerNames()>
									#gmmn[j]#<br>
								</cfloop>
							</td>
						</tr>
					</cfloop>
				</table>
				<br>
				<table width="100%" align="center" border="0" cellpadding="2" cellspacing="1" class="details">
					<tr class="firstrow">
						<th align="center" colspan="2">C O L L E C T I O N&nbsp;&nbsp;&nbsp;&nbsp;T I M E S&nbsp;&nbsp;&nbsp;&nbsp;A N D&nbsp;&nbsp;&nbsp;&nbsp;C O U N T S&nbsp;&nbsp;&nbsp;&nbsp;F O R&nbsp;&nbsp;&nbsp;&nbsp;E A C H&nbsp;&nbsp;&nbsp;&nbsp;T Y P E&nbsp;&nbsp;&nbsp;&nbsp;O F&nbsp;&nbsp;&nbsp;&nbsp;M E M O R Y&nbsp;&nbsp;&nbsp;&nbsp;P O O L</th>
					</tr>
					<cfloop index="i" from="1" to="#ArrayLen(mgmtFactory.GarbageCollectorMXBeans)#">
						<cfif i gt 1>
							<tr class="firstrow">
								<th align="center" colspan="2"></th>
							</tr>
						</cfif>
						<tr>
							<th align="right" class="firstth">Name:&nbsp;</th>
							<td><em><u>#mgmtFactory.GarbageCollectorMXBeans[i].getName()#</u></em></td>
						</tr>
						<tr>
							<th align="right" class="firstth">Collection Count:&nbsp;</th>
							<td>#mgmtFactory.GarbageCollectorMXBeans[i].getCollectionCount()#</td>
						</tr>
						<tr>
							<th align="right" class="firstth">Collection Time:&nbsp;</th>
							<td>#mgmtFactory.GarbageCollectorMXBeans[i].getCollectionTime()#</td>
						</tr>
						<tr>
							<th valign="top" align="right" class="firstth">Memory Pool Names:&nbsp;</th>
							<td>
								<cfloop index="j" from="1" to="#ArrayLen(mgmtFactory.GarbageCollectorMXBeans[i].getMemoryPoolNames())#">
									<cfset gmmn = mgmtFactory.GarbageCollectorMXBeans[i].getMemoryPoolNames()>
									#gmmn[j]#<br>
								</cfloop>
							</td>
						</tr>
					</cfloop>
				</table>
			</td>
		</tr>
	</table>
</cfoutput>

